Updated : Dec 15, 2012 in Linux

Installing ISTATD on Debian Squeeze/Wheezy

This HOW-TO is almost completely based on the README.txt file included in ISTATD package I included some adaptation notes.

istatd is a daemon serving statistics to your iStat iPhone application from Linux, Solaris & FreeBSD.
istatd collects data such as CPU, memory, network and disk usage and keeps the history.
Once connecting from the iPhone and entering the lock code this data will be sent to the iPhone and shown in fancy graphs.

What is iStat for iPhone?

iStat is a iPhone application developed by Bjango (http://bjango.com/help/istat/istatserverlinux/).
With iStat you can remotely monitor CPU, memory, disks, uptime and load averages from any Mac, Linux or Solaris computer from your iPhone.
You can find the latest version at: https://github.com/tiwilliam/istatd/downloads
You can download iStat for iPhone in iTunes App Store.

How to install
These steps assume you are logged in as root and have GNU build tools installed together with libxml2.

1) Download istatd-0.5.8.tar.gz
wget https://github.com/downloads/tiwilliam/istatd/istatd-0.5.8.tar.gz
or
wget http://public.itmatrix.eu/istatd-0.5.8.tar.gz

2) Extract tar ball
tar -xvf istatd-0.5.8.tar.gz
3) Install dependencies
istatd requires GNU build tools, libxml2 and libxml2-devel.
apt-get install libxml2-dev build-essential
4) Build istatd
cd istatd-0.5.8
Here you can configure where you want your binary and config to end up (default /usr/local).
./configure
or
./configure --prefix=/ --sysconfdir=/etc
# Build it
make && make install

5) Add user and configure directories
useradd istat
mkdir -p /var/{run,cache}/istat
chown istat.istat /var/{run,cache}/istat

Make a symlink to /etc/istat.conf
ln -s /usr/local/etc/istat.conf /etc/istat.conf
6) Configure your config to match your needs and system
Note: Don’t forget to change your server_code.
vim /etc/istat.conf
7) Fire it up
/usr/bin/istatd -d

7) Make sure it always starts at boot time
For this we will create an init script (/etc/init.d/istatd) and include it to most runlevels
Script suggested:

#! /bin/sh
### BEGIN INIT INFO
# Provides: istatd
# Required-Start: $remote_fs
# Required-Stop: $remote_fs
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: Server Monitoring agent for iStat on iPhone
# Description: Uses port 5109 to monitor basic system status for the iPhone iStat app
# placed in /etc/init.d.
### END INIT INFO
#
# Author: Michel Bisson(michelATlinuxintDOTcom)
#
# Please remove the "Author" lines above and replace them
# with your own name if you copy and modify this script.
#
# Do NOT "set -e"
#
# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="iStat system monitoring agent for iPhone istat.app"
NAME=istatd
DAEMON=/usr/local/bin/$NAME
DAEMON_ARGS="-d"
PIDFILE=/var/run/istat/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
#
# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0
#
# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
#
# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh
#
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions
#
#
# Function that starts the daemon/service
#
do_start()
{
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
|| return 1
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
$DAEMON_ARGS \
|| return 2
# Add code here, if necessary, that waits for the process to be ready
# to handle requests from services started subsequently which depend
# on this one. As a last resort, sleep for some time.
}
#
# Function that stops the daemon/service
#
do_stop()
{
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently. A last resort is to
# sleep for some time.
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
[ "$?" = 2 ] && return 2
# Many daemons don't delete their pidfiles when they exit.
rm -f $PIDFILE
return "$RETVAL"
}
#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
#
# If the daemon can reload its configuration without
# restarting (for example, when it is sent a SIGHUP),
# then implement that here.
#
start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
return 0
}
#
case "$1" in
start)
[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
do_start
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
stop)
[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
do_stop
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
#reload|force-reload)
#
# If do_reload() is not implemented then leave this commented out
# and leave 'force-reload' as an alias for 'restart'.
#
#log_daemon_msg "Reloading $DESC" "$NAME"
#do_reload
#log_end_msg $?
#;;
restart|force-reload)
#
# If the "reload" option is implemented then remove the
# 'force-reload' alias
#
log_daemon_msg "Restarting $DESC" "$NAME"
do_stop
case "$?" in
0|1)
do_start
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
*)
#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
exit 3
;;
esac

Make the script runnable and include it in boot sequence
chmod 755 /etc/init.d/istatd
update-rc.d istatd defaults

Start it manually for now.
(it will start automatically on reboot)
/etc/init.d/istatd start

NOTE: You can change the default port(5109) in /etc/istatd.conf, then make sure you open that port in your firewall.

Leave a Reply

This site uses Akismet to reduce spam. Learn how your comment data is processed.

%d bloggers like this: